<?php
if(!function_exists('sql_table')) {
	function sql_table($name) {return 'nucleus_'.$name;}
}
class NP_MultiTags extends NucleusPlugin {
	function getName() {return "MultiTags";}
	function getAuthor() {return "jun";}
	function getURL() {return "http://nucleus.mz-style.com/";}
	function getVersion() {return "2.511";}
	function getDescription() {return "Multiple Tags.";}
	function supportsFeature($what) {
		switch($what) {
		case 'SqlTablePrefix':
			return 1;
		default:
			return 0;
		}
	}

	function install() {
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_multitags').' (
			tagid int(11) not null auto_increment,
			tagname varchar(255) not null,
			titemid text not null,
			tcatid varchar(255) not null,
			taglevel tinyint(4) default "2" not null,
			tagdesc varchar(255),
			taggroup tinyint(4) default "1" not null,
			PRIMARY KEY (tagid),
			UNIQUE KEY tagname (tagname)
		)');
		$rs = mysql_query("SELECT * FROM ".sql_table('plugin_multitags'));
		switch(TRUE) {
		case(mysql_num_fields($rs) == 4) :
			sql_query("ALTER TABLE ".sql_table('plugin_multitags')." ADD (
				taglevel tinyint(4) default '2' not null,
				tagdesc varchar(255),
				taggroup tinyint(4) default '1' not null
			)");
			sql_query("UPDATE ".sql_table('plugin_multitags')." SET taglevel = '1' WHERE tcatid != ','");
			sql_query("UPDATE ".sql_table('plugin_multitags')." SET taggroup = '1'");
			break;
		case(mysql_num_fields($rs) == 6) :
			sql_query("ALTER TABLE ".sql_table('plugin_multitags')." ADD (
				taggroup tinyint(4) default '1' not null
			)");
			sql_query("UPDATE ".sql_table('plugin_multitags')." SET taggroup = '1'");
		}
		$this->TableCatAdd();
		$this->createOption('tag_query', _NP_MULTITAGS_OP_1, 'text', 'tag');
		$this->createOption('tag_item', _NP_MULTITAGS_OP_2, 'text', 'no');
		$this->createOption('tag_list', _NP_MULTITAGS_OP_3, 'text', '');
		$this->createOption('tag_num', _NP_MULTITAGS_OP_4, 'text', '10/36');
		$this->createOption('tag_switch', _NP_MULTITAGS_OP_5, 'text', '5/Top/Last/Prev/Next/*Results ');
		$this->createOption('tag_form', _NP_MULTITAGS_OP_6, 'text', '20/60');
		$this->createOption('tag_deltable', _NP_MULTITAGS_OP_7, 'yesno', 'no');
		$this->createOption('tag_quick', _NP_MULTITAGS_OP_8, 'yesno', 'yes');
		$this->createOption('tag_page', _NP_MULTITAGS_OP_9, 'text', '50');
		$this->createOption('tag_url', _NP_MULTITAGS_OP_10, 'text', '');
		$this->createOption('tag_level', _NP_MULTITAGS_OP_11, 'text', '2');
		$this->createOption('tag_key', _NP_MULTITAGS_OP_12, 'yesno', 'no');
		global $catid;
		$this->createCategoryOption('tag_cat', _NP_MULTITAGS_OP_C, 'yesno', 'yes');
	}

	function unInstall() {
		if($this->getOption('tag_deltable') == 'yes') {
			mysql_query("DROP table ".sql_table('plugin_multitags'));
		}
		$this->deleteOption('tag_query');
		$this->deleteOption('tag_item');
		$this->deleteOption('tag_list');
		$this->deleteOption('tag_num');
		$this->deleteOption('tag_switch');
		$this->deleteOption('tag_form');
		$this->deleteOption('tag_deltable');
		$this->deleteOption('tag_quick');
		$this->deleteOption('tag_page');
		$this->deleteOption('tag_cat');
		$this->deleteOption('tag_url');
		$this->deleteOption('tag_level');
		$this->deleteOption('tag_key');
	}

	function getTableList() {return array(sql_table('plugin_multitags'));}

	function hasAdminArea() {	return 1;}

	function getEventList() {return array('QuickMenu', 'PreItem', 'AddItemFormExtras', 'EditItemFormExtras', 'PostAddItem', 'PreUpdateItem', 'PostDeleteItem', 'PostAddCategory', 'PostDeleteCategory', 'AdminPrePageHead', 'PostPluginOptionsUpdate');}

	function event_QuickMenu(&$data) {
		global $member;
		if($this->getOption('tag_quick') == 'no') return;
		if(!$member->isAdmin()) return;
		array_push(
			$data['options'],
			array(
				'title' => 'MultiTags',
				'url' => $this->getAdminURL(),
				'tooltip' => _NP_MULTITAGS_ADMIN
			)
		);
	}

	function event_PreItem(&$data) {
		$this->currentItem = &$data['item'];
		$title = $this->getOption('tag_item');
		switch(TRUE) {
		case($title == 'no') :
			return;
		case($title) :
			$pos = "'<div class=\"tagitem\">\n$title \\1\n</div>'";
			$this->currentItem->body = preg_replace("/\[\[\[(.*)\]\]\]/e", $pos, $this->currentItem->body);
			return;
		}
	}

	function event_AddItemFormExtras($data) {$this->TableForm();}

	function event_EditItemFormExtras($data) {$this->TableForm(1);}

	function event_PostAddItem($data) {
		$ids = requestIntArray('multitags');
		switch(TRUE) {
		case($ids):
			$id = $data['itemid'];
			if($ids[0]) $words = array_shift($ids);
			$ids = implode(',', $ids);
			$icat = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber = '.$id.' ORDER BY null LIMIT 1');
			$res1 = quickQuery('SELECT tagid as result FROM '.sql_table('plugin_multitags').' WHERE tcatid REGEXP ",'.$icat.',"');
			if($res1) $noc = $icat;
			$this->TableUpdate('titemid', 'add', $id, $ids, $noc);
			if($words) $this->AddTag($words, $id);
		}
	}

	function event_PreUpdateItem($data) {
		$ids = requestIntArray('multitags');
		$id = $data['itemid'];
		if($ids[0]) $words = array_shift($ids);
		if($ids) $ids = implode(',', $ids);
		$this->TableUpdate('titemid', 'up', $id, $ids);
		if($words) $this->AddTag($words, $id);
	}

	function event_PostDeleteItem($data) {
		$this->TableUpdate('titemid', 'del', $data['itemid']);
	}

	function event_PostAddCategory($data) {$this->TableCatAdd($data['catid']);}

	function event_PostPluginOptionsUpdate(&$data) {
//		if($data['plugid'] != $this->getID()) return;
		if($data['context'] == 'category' && $this->getOption(tag_cat) == 'yes') {
			$this->TableUpdate('tcatid', 'up', $data['catid']);
		}
		$level = $this->getOption(tag_level);
		if($data['context'] == 'global') {
			sql_query('ALTER TABLE '.sql_table('plugin_multitags').' CHANGE taglevel taglevel tinyint(4) not null default "'.$level.'"');
		}
	}

	function event_PostDeleteCategory($data) {
		$this->TableUpdate('tcatid', 'del', $data['catid']);
	}

	function event_AdminPrePageHead(&$data) {
		global $CONF;
		if($data['action'] == 'plugin_'.$this->getName()) $data['extrahead'] .= '
			<link rel="stylesheet" type="text/css" href="'.$this->getAdminURL().$this->getName().'.css" />
';
	}

	function init() {
		$language = ereg_replace( '[\\|/]', '', getLanguageName());
		if(file_exists($this->getDirectory().$language.'.php')) {
			include_once($this->getDirectory().$language.'.php');
		}else {
			include_once($this->getDirectory().'english.php');
		}
	}

	function TagList($itemid = '', $num = '', $tem = '', $op = '') {
		if(!$num) $num = 10;
		$cid = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber ='.$itemid);
		if(!$op) $cat = ' or tcatid REGEXP ",'.$cid.',"';
		$result = sql_query('SELECT DISTINCT tagname FROM '.sql_table('plugin_multitags').' WHERE (titemid REGEXP ",'.$itemid.',"'.$cat.') and taglevel != -1 ORDER BY taglevel LIMIT '.$num);
		while(list($c1) = mysql_fetch_row($result)) $ilink .= substr($tem, 0, 1).$c1.substr($tem, 1, 1).' ';
		mysql_free_result($result);
		return $ilink;
	}

	function doTemplateCommentsVar(&$item, &$comment, $mode = '') {
		$this->doTemplateVar(&$item, $mode);
	}

	function doTemplateVar(&$item, $mode = '', $num = '', $tem = '', $op = '') {
		global $CONF, $manager, $blogid;
		$itemid = $item->itemid;
		$que = $this->getOption('tag_query');
		switch(TRUE) {
		case($mode == 'body') :
			echo $this->TagChange($item->body, $num);
			return;
		case($mode == 'more') :
			echo $this->TagChange($item->more, $num);
			return;
		case($mode == 'title') :
			echo $this->TagChange($item->title, $num);
			return;
		case($mode == 'bm') :
			$text = $item->body.' '.$item->more;
			echo $this->TagChange($text, $num);
			return;
		case($mode == 'list') :
			$ilink = $this->TagList($itemid, $num, $tem, $op).$this->EditItemTag($itemid);
			break;
		case($mode == 'ed') :
			$ilink = $this->EditItemTag($itemid);
			break;
		case($mode == 'c') :
			$bid = quickQuery('SELECT iblog as result FROM '.sql_table('item').' WHERE inumber ='.$itemid);
			$cat = $this->GetCatName(0, $itemid);
			$ilink = $this->FancyURL($bid, $que, $cat);
			break;
		default :
			switch(TRUE) {
			case($CONF['URLMode'] == 'normal' || $this->getOption('tag_url') == 2) :
				$qq = $_GET[$que];
				break;
			default :
				$lq = explode('/'.$que.'/', $_SERVER['REQUEST_URI']);
				$lr = explode('/', $lq[1]);
				$ls = explode('?', $lr[0]);
				$qq = str_replace('+' ,' ', $ls[0]);
			}
			$ilink = $this->ItemURL($itemid, $que, $qq);
		}
		$catid = '';
		$itemid = '';
		echo $ilink;
	}

	function doSkinVar($skinType, $template = '', $mitem = '', $mblog = '', $mswitch = '', $msort = '', $mcat = '', $mlevel = '') {
		global $CONF, $blogid, $catid, $itemid, $member, $archive;
		$temple = explode('/', $template);
		$mitem = explode('/', $mitem, 4);
		$msw = explode('/', $mswitch);
// Tag or Search Query
		$que = $this->getOption('tag_query');
		switch(TRUE) {
		case($_GET['query'] && substr($mitem[2] ,0, 1) == 's') :
			$que = 'query';
			break;
		case(!$que) :
			$que = 'que';
		}
		if(!$mitem[0]) $mitem[0] = 10;
		$bid = ($mitem[2] > 0) ? $mitem[2] : $blogid;
		if(substr($mitem[2] ,0, 3) == 'tag') {
			$mitem[3] = str_replace('/', ' ', $mitem[3]);
			$tagset = 1;
		}
		$qqtt = $this->TagQuery($tagset, $que, $temple[0], $mitem[3]);
		$qq = $qqtt[0];
		$lq = $qqtt[1];
		if($_GET[$que] || $lq[1]) $gque = 1;
		if($qq) $qq = $this->QueryChange(' '.$qq);
		$qq1 = explode(' ', htmlspecialchars(trim($qq)));
		$qq2 = array_unique($qq1);
		if($qq) foreach($qq2 as $qq_q) if(!is_numeric($qq_q)) $qjd .= 1;
// TagNavi and SerchForm
		switch(TRUE) {
		case($template == 'navi') :
			echo $this->TagNavi($qq2, $bid, $que, $qjd, $gque);
			return;
		case($template == 'title') :
			echo $this->TagNavi($qq2, $bid, $que, $qjd, $gque, 1);
			return;
		case($template == 'ad') :
			echo $this->TagNavi($qq2, $bid, $que, $qjd, $gque, 2);
			return;
		case($template == 'form') :
			echo $this->SerchForm($qq, $que, $msw, '', $qq2, $qjd);
			return;
		}
		$wh = ' idraft = 0 and itime <= "'.date('Y-m-d H:i:s').'"';
		$where = $wh;
		if($mitem[1] == 'cat') $cna = ', cname';
		$fields = 'CONCAT(ititle, ibody, imore'.$cna.')';
// Join Item
		switch(TRUE) {
		case($mitem[1] == 'join' && $itemid) :
			$qq2 = '';
			$icats = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber ='.$itemid);
			$result = sql_query('SELECT tagid FROM '.sql_table('plugin_multitags').' WHERE titemid REGEXP ",('.$itemid.')," or tcatid REGEXP ",('.$icats.')," ORDER BY null');
			while(list($c1) = mysql_fetch_row($result)) $qq2[] = $c1;
			mysql_free_result($result);
			shuffle($qq2);
			if(!$mitem[2]) $mitem[2] = 2;
			if(count($qq2)>$mitem[2]) $qq2 = array_slice($qq2, 0 ,$mitem[2]);
		}
// Category
		$mcats = explode('/', $mcat, 2);
		switch($mcats[0]) {
		case '':
			break;
		case 'no':
			$mcat = explode('/', $mcats[1]);
			foreach($mcat as $mcats) $where .= ' and icat != '.$mcats;
			break;
		case 's':
			$s2 = quickQuery('SELECT ititle as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
			$s3 = explode(' ', $s2);
			$where .= ($s3[1]) ? ' and '.$fields.' LIKE "%'.$s3[1].'%" and inumber !='.$itemid : ' and inumber is null';
			break;
		default:
			$mcat = str_replace('/', ', ', $mcat);
			$where .= ' and icat in ('.$mcat.')';
		}
// Blog
		$mblogs = explode('/', $mblog, 2);
		switch($mblogs[0]) {
		case '':
			$where .= ' and iblog = '.$blogid;
			if(!$mcats[0] && $catid) $where .= ' and icat = '.$catid;
			break;
		case 'all':
			break;
		case 'no':
			$mblog = explode('/', $mblogs[1]);
			foreach($mblog as $mblogs) $where .= ' and iblog != '.$mblogs;
			break;
		default:
			$mblog = str_replace('/', ', ', $mblog);
			$where .= ' and iblog in ('.$mblog.')';
		}
// Tag set
		switch(TRUE) {
		case($msw[0] == 'a' || $msw[0] == 'b' || $mitem[1] == 'item' || $mcat == 's' || ($mitem[1] == 'non' && $mitem[2] != 's') || $mitem[1] == 'map') :
			$tagque = ' tagid is not null';
			$ijd = 1;
			break;
		case($mitem[2] == 'tag' || ($_GET['search'] && $temple[0] != 'tag' && $mitem[2] != 'tagid')) :
			foreach($qq2 as $qq_e) $tagque .= ' tagname = "'.$qq_e.'" or';
			$tagque = substr($tagque ,0, -3);
			break;
		case(($gque && !$qjd && !$itemid) || $mitem[2] == 'tagid' || ($mitem[1] == 'join' && $itemid)) :
			if(!$qq2) {
				echo '<p>'._NP_MULTITAGS_NOITEM.'</p>';
				return;
			}
			$tagque = ' tagid in ('.implode(',', $qq2).')';
			$tjd = 1;
			break;
		default:
			$tagque = ' tagid is not null';
		}
// Archive
		switch(TRUE) {
		case($archive && !($ijd || $mitem[2] == 'tag' || $mitem[2] == 'tagid')):
			sscanf($archive, '%d-%d-%d', $y, $m, $d);
			switch(TRUE) {
			case($d):
				$time_s = mktime(0, 0, 0, $m, $d, $y);
				$time_e = mktime(0, 0, 0, $m, $d+1, $y);
				break;
			case($m):
				$time_s = mktime(0, 0, 0, $m, 1, $y);
				$time_e = mktime(0, 0, 0, $m+1, 1, $y);
			}
			$where .= ' and itime >= '.mysqldate($time_s).' and itime < '.mysqldate($time_e);
		}
// Tag query
		switch(TRUE) {
		case($mitem[1] != 'non') :
			$i = 0;
			$ii = 0;
			$mle = explode('/', $mlevel);
			$mlev = ($gque) ? count($qq1)+1 : 1;
			if($mle[0] == 'fix' && !$mle[1]) $mle[1] = 3;
			switch(TRUE) {
			case($mlevel == 'all' || $tagset) :
				break;
			case(($mle[0] == 'fix' && $mle[1]>$mlev-1) && !$itemid) :
				$tl2 = ' and taglevel = "'.$mlev.'"';
				break;
			case($ijd || (($itemid || (($_GET['search'] || $_GET['query']) && $temple[0] != 'tag' && count($qq2) == 1)) && !$ijd)) :
				$tlev = ' and taglevel != -1';
				if($msw[0] == 'a' || $msw[0] == 'b') $tlev2 = ' and taglevel in ('.implode(',', $mle).')';
				break;
			case($mlevel && $mle[0] != 'fix') :
				$tlev = ' and taglevel != -1';
				$tlev2 = ' and taglevel in ('.implode(',', $mle).')';
				break;
			default :
				$tlev = ' and taglevel between 1 and '.$mlev;
			}
			if($itemid && !$tagset && !$ijd && !$icats) $ique = ' and inumber = '.$itemid;
			$result = sql_query('SELECT titemid, tcatid FROM '.sql_table('plugin_multitags').' WHERE'.$tagque.$tlev.' ORDER BY null');
			while(list($c1, $c2) = mysql_fetch_row($result)) {
				$tagx[$i] = $c1.'^^^'.$c2;
				$i++;
			}
			mysql_free_result($result);
			$t2 = $this->getOption('tag_list');
			switch(TRUE) {
			case($i < 1 && $temple[0] != 'tag' && $temple[0] != 'meta') :
				$this->MultiTags($template, $mitem, $msw, $msort, $qq2, $que, $qq, $iid7, $where, $fields, $tagset, $gque);
				return;
			case($i < 1 && $temple[1] != 'ad') :
				if($t2) echo "\n<div class=\"tagtitle\">\n".$t2."\n</div>\n";
				if($temple[0] != 'meta') echo '<div class="tagbody">'._NP_MULTITAGS_NOTAG.'</div>';
				return;
			case($i < 1 && $temple[1] == 'ad') :
				$this->AdWord('', $temple[2], $temple[3]);
				return;
			}
			foreach($tagx as $ix) {
				$ix = explode('^^^', $ix);
				$ix0 = '';
				$ix1 = '';
				if($ix[0] != ',') {
					$ix[0] = preg_replace('/^,|,$/', '', $ix[0]);
					$iquery = sql_query('SELECT DISTINCT inumber FROM '.sql_table('item').' WHERE '.$where.' and inumber in ('.$ix[0].')'.$ique);
					while(list($i9) = mysql_fetch_row($iquery)) $ix1 .= ','.$i9.',';
					mysql_free_result($iquery);
				}
				if($ix[1] != ',' && $mitem[1]) {
					$cid = preg_replace('/^,|,$/', '', $ix[1]);
					$cid7 = $cid.','.$cid7;
					$cquery = sql_query('SELECT DISTINCT inumber FROM '.sql_table('item').' WHERE '.$where.' and icat in ('.$cid.')'.$ique);
					while(list($c9) = mysql_fetch_row($cquery)) $ix0 .= ','.$c9.',';
					mysql_free_result($cquery);
				}
				$iidx[$ii] = implode(',', array_unique(explode(',', $ix1.$ix0)));
				$ii++;
			}
			$iids = array_count_values(explode(',', implode(',', $iidx)));
			foreach($iids as $k7=>$n7) if($n7 == $i || $_GET['search'] || $msw[0] == 'a' || $msw[0] == 'b' || $mitem[1] == 'map' || $tagset || !$tjd) $iid7 .= $k7.'|';
			$iid7 = preg_replace('/^\||\|$/', '', $iid7);
			$iidc7 = str_replace('|', ',', $iid7);
			if($iidc7 && $mitem[1]) {
				$dc7que = sql_query('SELECT DISTINCT icat FROM '.sql_table('item').' WHERE inumber in ('.$iidc7.')'.$ique);
				while(list($dc7) = mysql_fetch_row($dc7que)) $cid7 .= $dc7.',';
				mysql_free_result($dc7que);
			}
			if($iid7 != '') $iid8 = 'titemid REGEXP ",('.$iid7.')," or ';
			$cid7 = str_replace(',', '|', substr($cid7 ,0, -1));
			if(!$mitem[1]) $nocat = ' and tcatid = ","';
			if(!$tagset && !$_GET['search'] && $msw[1] == 'g') {
				switch(TRUE) {
				case($qq) :
					$tg = quickQuery('SELECT taggroup as result FROM '.sql_table('plugin_multitags').' WHERE tagid ='.$qq1[0]);
					break;
				case($itemid) :
					$tg = quickQuery('SELECT MIN(taggroup) as result FROM '.sql_table('plugin_multitags').' WHERE titemid REGEXP ",('.$itemid.'),"');
				}
				if($tg) $tlev .= ' and taggroup = '.$tg;
			}
			if($mlevel && $mle[0] != 'fix') $tlev = $tlev2; 
			$query = 'SELECT DISTINCT * FROM '.sql_table('plugin_multitags').' WHERE ('.$iid8.'tcatid REGEXP ",('.$cid7.'),")'.$nocat.$tlev.$tl2;
			break;
		default :
			$query = 'SELECT DISTINCT * FROM '.sql_table('plugin_multitags');
		}
// MultiTags
		if($temple[0] != 'tag' && $temple[0] != 'meta' && $mitem[1] != 'group') {
			$this->MultiTags($template, $mitem, $msw, $msort, $qq2, $que, $qq, $iid7, $where, $fields, $tagset, $gque);
			return;
		}
		$query .= $this->TagSort($msort);
		$tg = sql_query($query);
		while($row = mysql_fetch_assoc($tg)) {
			$titemid = $row['titemid'];
			$tcatid = preg_replace('/^,|,$/', '', implode(',', array_unique(explode(',', $row['tcatid']))));
			if($tcatid) {
				$cque = sql_query('SELECT DISTINCT inumber FROM '.sql_table('item').' WHERE icat in ('.$tcatid.')');
				while(list($c6) = mysql_fetch_row($cque)) $titemid .= $c6.',';
				mysql_free_result($cque);
			}
			$titemid = preg_replace('/^,|,$/', '', $titemid);
			$titemid = array_unique(explode(',', $titemid));
			$iid5 = explode('|', $iid7);
			$cnum = ($i) ? count(array_intersect($titemid, $iid5)) : count($titemid);
			switch(TRUE) {
			case($mitem[1] != 'map' && $mitem[1] != 'catid') :
				break;
			case($mle[0]) :
				if($row['taglevel'] != $mle[1] && $mle[0] != 'all') $cnum = 0;
				break;
			case($row['tcatid'] == ',') :
				$cnum = 0;
			}
			$word = $row['tagname'].'^^^'.$row['tagid'].'^^^'.$row['titemid'].'^^^'.$row['tcatid'].'^^^'.$row['taglevel'].'^^^'.$row['tagdesc'];
			if($cnum) $words[$word] = $cnum;
		}
		mysql_free_result($tg);
// Sort
		switch(TRUE) {
		case(!count($words)) :
			if($temple[0] != 'meta') echo '<div class="tagbody">'._NP_MULTITAGS_NOTAG.'</div>';
			if($temple[1] == 'ad') $this->AdWord('', $temple[2], $temple[3]);
			return;
		case($msort == 4) :
			ksort($words);
			break;
		case($msort == 1) :
			asort($words);
			break;
		case($msort == 3) :
			krsort($words);
			break;
		case($msort == 2 || $msort > 5) :
			break;
		default :
			arsort($words);
		}
// View
		if($msw[0] ==1 || $msw[0] == 'b') $this->TagNavi($qq2, $bid, $que, $qjd, $gque);
		switch(TRUE) {
		case(!$temple[1]):
			$m1 = 'div';
			$m1a = 'span';
			break;
		case($temple[1] == 'dd'):
			$m1a = 'dd';
			break;
		default:
			$m1 = $temple[1];
			$m1a = ($temple[1] == 'ol' || $temple[1] == 'ul') ? 'li' : 'span';
		}
		if($t2 && $word && $temple[0] != 'meta') echo "\n<div class=\"tagtitle\">\n".$t2."\n</div>\n";
		switch(TRUE) {
		case($word) :
			if($mitem[0] != 'all') $words = array_slice($words, 0 ,$mitem[0]);
			$qqq = stripslashes($qq);
			if($m1) $head = "<".$m1." class=\"tagbody\">\n";
			if($m1) $foot = "</".$m1.">\n";
			foreach($words as $key=>$num) {
				$key0 = explode('^^^', $key);
				$kdd = $this->TagDesc($key0[5], $mitem[3]);
				switch(TRUE) {
				case($itemid && !($msw[0] == 'a' || $msw[0] == 'b' || $mitem[1] == 'map')) :
					$ke3 = preg_replace('/^,|,$/', '', $key0[3]);
					if($ke3) {
						$s9 = sql_query('SELECT DISTINCT inumber FROM '.sql_table('item').' WHERE'.$wh.' and icat in ('.$ke3.')');
						while(list($e1) = mysql_fetch_row($s9)) $key0[2] .= $e1.',';
						mysql_free_result($s9);
					}
					$num = count(array_unique(explode(',', $key0[2])))-1;
					$iqu = 1;
				}
				$nn = $this->CountNumber($msw, $temple, $key, $num, $mitem[1]);
				$key1 = ($qqq == $key0[0] || $msw[0] == 'a' || $msw[0] == 'b' || $itemid || $_GET['search'] || $mitem[1] == 'map' || $mitem[2] == 'group') ? $key0[1] : trim($qqq.' '.$key0[1]);
				switch(TRUE) {
				case($mitem[2] == 'all') :
					$ik0 = '';
					$ik1 = '';
					if($key0[2] != ',') {
						$key0[2]= preg_replace('/^,|,$/', '', $key0[2]);
						$ikq = sql_query('SELECT iblog FROM '.sql_table('item').' WHERE '.$where.' and inumber in ('.$key0[2].')'.$ique);
						while(list($ki9) = mysql_fetch_row($ikq)) $ik1 .= $ki9.',';
						mysql_free_result($ikq);
					}
					if($key0[3] != ',' && $mitem[1]) {
						$key0[3] = preg_replace('/^,|,$/', '', $key0[3]);
						$ckq = sql_query('SELECT iblog FROM '.sql_table('item').' WHERE '.$where.' and icat in ('.$key0[3].')'.$ique);
						while(list($kc9) = mysql_fetch_row($ckq)) $ik0 .= $kc9.',';
						mysql_free_result($ckq);
					}
					$ik2 = array_count_values(explode(',', $ik1.$ik0));
				}
				$q0jd = '';
				foreach($qq2 as $qq01) if($key0[1] == $qq01) $q0jd .= 1;
				switch(TRUE) {
				case(!$key) :
					break;
				case($temple[0] == 'meta') :
					$text .= ($temple[1] == 'ad') ? $key0[0].' ' : $key0[0].',';
					break;
				case($q0jd && !$itemid && $mitem[1] != 'map' && !$_GET['search'] && $msw[0] != 'a' && $msw[0] != 'b') :
					switch(TRUE) {
					case($mitem[2] != 'all') :
						$text .= '<'.$m1a.' class="tagselect"'.$nn[1].'>'.$key0[0].$nn[0].$kdd[1].'</'.$m1a."> \n";
						break;
					default :
						foreach($ik2 as $bid6=>$nn6) {
							$nn6 = $this->CountNumber($msw, $temple, $key, $nn6);
							switch(TRUE) {
							case($bid6 == $bid) :
								$text .= '<'.$m1a.' class="tagselect"'.$nn6[1].'>'.$key0[0].$nn6[0].'</'.$m1a."> \n";
								break;
							case($bid6) :
								$text .= '<'.$m1a.' class="tagsub"'.$nn6[1].'><a href="'.$this->FancyURL($bid6, $que, $key1, $ijd).'"'.$kdd[0].'>'.$key0[0].'</a>'.$nn6[0].$kdd[1].'</'.$m1a."> \n";
							}
						}
					}
					break;
				default :
					$ss = ($mitem[1] == 'map' && $m1a == 'li') ? '<'.$m1a.'><div class="tagsubmap"' : '<'.$m1a.' class="tagsub"';
					if($itemid && !$qq) {
						$sq1 = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
						$sq2 = quickQuery('SELECT tagid as result FROM '.sql_table('plugin_multitags').' WHERE tcatid REGEXP ",'.$sq1.',"');
						if($sq2 == $key0[1]) $q0jd = 1;
					}
					if($q0jd) $ss = ($mitem[1] == 'map' && $m1a == 'li') ? '<'.$m1a.'><div class="tagselect"' : '<'.$m1a.' class="tagselect"';
					if($mitem[1] == 'map' && $m1a == 'li') $ss2 = '</div>';
					$mm1 = '</'.$m1a.">\n";
					switch(TRUE) {
					case($mitem[2] != 'all') :
						if($mitem[1] == 'map') $nn[1] = '';
						$t00 = $ss.$nn[1].'><a href="'.$this->FancyURL($bid, $que, $key1, $ijd).'"'.$kdd[0].'>'.$key0[0].'</a>'.$nn[0].$kdd[1].$ss2;
						$text0 = ($mitem[1] == 'map' && $m1a == 'li') ? $mm1.$t00." \n" : $t00.$mm1;
						break;
					default :
						$text0 = '';
						foreach($ik2 as $bid5=>$nn5) if($bid5) {
							$nn5 = $this->CountNumber($msw, $temple, $key, $nn5);
							if($mitem[1] == 'map') $nn5[1] = '';
							$t00 = $ss.$nn5[1].'><a href="'.$this->FancyURL($bid5, $que, $key1, $ijd).'"'.$kdd[0].'>'.$key0[0].'</a>'.$nn5[0].$kdd[1].$ss2;
							$text0 .= ($mitem[1] == 'map' && $m1a == 'li') ? $mm1.$t00." \n" : $t00.$mm1;
						}
					}
					switch(TRUE) {
					case($mitem[1] != 'map') :
						$text .= $text0;
						break;
					default :
						$kci1 = '';
						$key0[3] = preg_replace('/^,|,$/', '', $key0[3]);
						switch(TRUE) {
						case($key0[3]) :
							$resc = sql_query('SELECT inumber FROM '.sql_table('item').' WHERE icat in ('.$key0[3].')');
							while(list($kci) = mysql_fetch_row($resc)) $kci1 .= '|'.$kci;
							mysql_free_result($resc);
						}
						$k2 = str_replace(',', '|', $key0[2]);
						$k2 = preg_replace('/^\|+|\|$/', '', $k2.$kci1);
						$k2 = preg_replace('/\|\|/', '|', $k2);
						switch($mle[0]) {
						case 'auto' :
							$mle2 = array_slice($mle, 1);
							$talev = 'in ('. implode(',', $mle2).')';
							break;
						case 'fixs' :
							$talev = '= '.$mle[2];
							break;
						default :
							$talev = '!= -1';
						}
						if($mitem[3]) $tds = ',tagdesc ';
						$result = sql_query('SELECT tagid, tagname, titemid'.$tds.' FROM '.sql_table('plugin_multitags').' WHERE titemid REGEXP ",('.$k2.')," and tagid != '.$key0[1].' and taglevel '.$talev.$this->TagSort($msort));
						$k2 = array_unique(explode('|', $k2));
						while(list($ki, $kn, $kii, $kd) = mysql_fetch_row($result)) {
							$kii = preg_replace('/^,|,$/', '', $kii);
							$inum = sql_query('SELECT inumber FROM '.sql_table('item').' WHERE '.$where.' and inumber in ('.$kii.')');
							$kii1 = '';
							while(list($kig) = mysql_fetch_row($inum)) $kii1 .= $kig.',';
							mysql_free_result($inum);
							$kii2 = explode(',', $kii1);
							$n1 = count(array_intersect($k2, $kii2));
							$nn1 = $this->CountNumber($msw, $temple, $key, $n1);
							if($mitem[2] == 'all') foreach($ik2 as $bid8=>$nn8) if($bid8) $bid = $bid8;
							$kdd = $this->TagDesc($kd, $mitem[3]);
							$q1jd = '';
							foreach($qq2 as $qq11) if($ki == $qq11) $q1jd .= 1;
							$dd = ($q1jd) ? 'tagselect' : 'tagsub';
							if($n1) $text0 .= $head.'<'.$m1a.' class="'.$dd.'"'.$nn1[1].'><a href="'.$this->FancyURL($bid, $que, $key1.' '.$ki, $ijd).'"'.$kdd[0].'>'.$kn.'</a>'.$nn1[0].$kdd[1].'</'.$m1a."> \n".$foot;
						}
						mysql_free_result($result);
						$text .= $head.$text0.$foot;
					}
				}
			}
			switch(TRUE) {
			case($temple[0] == 'meta' && $temple[1] == 'ad') :
				$this->AdWord($text, $temple[2], $temple[3]);
				return;
			case($temple[0] == 'meta') :
				$m0 = ($temple[0] == 'a') ? array('&lt;', '&gt;') : array('<', '>');
				if($text) echo $m0[0].'meta name="keywords" content="'.substr($text ,0, -1).'" /'.$m0[1];
				break;
			case($mitem[2] == 'group') :
				break;
			case($mitem[1] != 'map') :
				echo $head.$text.$foot;
				break;
			default :
				$text = str_replace($foot.$head, '', $foot.$text.$head);
				echo "<".$m1." class=\"tagmap\">\n".$text.$foot;
			}
		}
	}

	function AdWord($text = '', $mode = 'u1', $level = '') {
		if(!$level) $level = 2;
		if(!$text) $text = quickQuery('SELECT tagname as result FROM '.sql_table('plugin_multitags').' WHERE taglevel in ('.$level.') ORDER BY RAND() LIMIT 1');
		if(substr($mode ,2, 1) == 'a') $add = '">'.$text.'</a>';;
		if(substr($mode ,0, 1) == 'u') $text = mb_convert_encoding($text, 'UTF-8', 'EUC-JP');
		if(substr($mode ,0, 1) == 'e') $text = mb_convert_encoding($text, 'EUC-JP', 'UTF-8');
		if(substr($mode ,1, 1) == '1') $text = urlencode($text);
		if(substr($mode ,1, 1) == '2') $text = urlencode(urlencode($text));
		echo $text.$add;
	}

	function TagDesc($kd = '', $mit = '') {
		$kd1 = '';
		$kd2 = '';
		switch(TRUE) {
		case($mit == 1) :
			$kd1 = ' title="'.$kd.'"';
			break;
		case($mit) :
			$kd2 = '<span class="tagdesc">'.$mit.$kd.'</span>';
		}
		return array($kd1, $kd2);
	}

	function CountNumber($msw = '', $temple = '', $key = '', $num = '', $map = '') {
		switch(TRUE) {
		case($temple[2] > 0) :
			if($temple[3] < 2) $n = '<span class="tagnum">('.$num.')</span>';
			$tnum = explode('/', $this->getOption('tag_num'));
			$num2 = ($temple[2]*$num>$tnum[1]) ? $tnum[1] : $tnum[0]+$temple[2]*$num;
			$size = ' style="font-size: '.$num2.'px;"';
			break;
		case($temple[2]) :
			break;
		case(($key || $msw[0] == 'a' || $msw[0] == 'b') && $temple[3] < 2) :
			$n = '<span class="tagnum">('.$num.')</span>';
		}
		$nn = array($n, $size);
		return $nn;
	}

	function MultiTags($template = '', $mitem = '', $msw = '', $msort = '', $qq2 = '', $que = '', $qq = '', $iid7 = '', $where = '', $fields = '', $tagset = '', $gque = '', $words = '') {
		global $CONF, $blogid, $catid, $itemid, $manager, $blog, $archive;
		$q1 = ' inumber as itemid, iblog as blog, ibody as body, mname as author, mrealname as authorname, UNIX_TIMESTAMP(itime) as timestamp, itime, imore as more, mnumber as authorid, cname as category, icat as catid, iclosed as closed, memail as authormail, murl as authorurl, ititle as title';
		$q2 = ' FROM '.sql_table('item').', '.sql_table('member').', '.sql_table('category');
		$q3 = ' WHERE iauthor = mnumber and icat = catid';
// Search or Tag
		switch(TRUE) {
		case(($_GET['query'] || $_GET['search']) && substr($mitem[2] ,0, 1) == 's') :
			foreach($qq2 as $qq_e) $where .= ' and '.$fields.' LIKE "%'.$qq_e.'%"';
			break;
		case($iid7 && (!$_GET['search'] || $tagset)) :
			$where .= ' and inumber in ('.str_replace('|', ',', $iid7).')';
			if($mitem[1] == 'join' && $itemid) $where .= ' and inumber != '.$itemid;
		}
		$q4 = ' and '.$where;
// Sort
		$sort1 = ($_GET['act'] != 'rv') ? ASC : DESC;
		$sort2 = ($_GET['act'] != 'rv') ? DESC : ASC;
		switch($msort) {
		case '1':
			$q5 = 'itime '.$sort1;
			break;
		case '2':
			$q5 = 'RAND()';
			break;
		case '3':
			$q5 = 'ititle '.$sort2;
			break;
		case '4':
			$q5 = 'ititle '.$sort1;
			break;
		default:
			$q5 = 'itime '.$sort2;
		}
		$query = 'SELECT DISTINCT '.$q1.$q2.$q3.$q4;
// Page switch
		$rr = mysql_query($query);
		if($rr) $nums = mysql_num_rows($rr);
		list($links, $page) = explode('page=', $_SERVER['REQUEST_URI']);
		if(!$page) $page = 1;
		$num = ($mitem[0]>$nums || !$msw[0]) ? 0 :($page-1)*$mitem[0];
		$last = ($mitem[0]) ? ceil($nums/$mitem[0]) : '';
		switch(TRUE) {
		case(($last>1 && !$itemid && $msw[0]) || $msw[2]) :
			$pj = substr($links, -1);
			$link = ($pj == '&' || $pj == '?') ? substr($links ,0, -1) : $links;
			$link .= (preg_match("/\?/", $links) && $pj != '?') ? '&amp;page=' : '?page=';
			$nn = explode('/', $this->getOption('tag_switch'));
			switch(TRUE) {
			case($msw[0] == 2) :
				if(!$nn[0]) $nn[0] = 5;
				if($page>$nn[0]+1) $ps1 = '..';
				for($j=$page-$nn[0]; $j<=$page+$nn[0]; $j++) {
					switch(TRUE) {
					case($j>0 && $j<=$last && $j<>$page) :
						$ps1 .= ' <a href="'.$link.$j.'" title="P.'.$j.'">'.$j."</a> \n";
						break;
					case($j==$page) :
						$ps1 .= ' <strong>'.$j."</strong> \n";
					}
				}
				if($last>$page+$nn[0]) $ps1 .= '..';
				$pswp = ($page != 1) ? '<a href="'.$link.($page-1).'" title="'.$nn[3].'">&laquo;&laquo;</a>' : '&laquo;&laquo;';
				$pswn = ($page != $last) ? '<a href="'.$link.($page+1).'" title="'.$nn[4].'">&raquo;&raquo;</a>' : '&raquo;&raquo;';
				$psw = '<a href="'.$link."1\" title=\"P.1\">$nn[1]</a> $pswp \n".$ps1.' '.$pswn.' <a href="'.$link.$last."\" title=\"P.$last\">$nn[2]</a>\n";
				break;
			default :
				$psw = ($page != 1) ? '<a href="'.$link.($page-1).'">'.$nn[3].'</a>' : $nn[3];
				$psw .= ' ['.$page.'/'.$last.'] ';
				$psw .= ($page != $last) ? '<a href="'.$link.($page+1).'">'.$nn[4].'</a>' : $nn[4];
			}
			if($last<=1) $psw = '';
			if($msw[2] && $nums) {
				$lp = ($page*$mitem[0]<$nums) ? $mitem[0]*$page : $nums;
				$psw .= $nn[5].(($page-1)*$mitem[0]+1).'-'.$lp.' of '.$nums.' ';
			}
			if($msw[2] == 2) $psw = $this->SerchForm($qq, $que, $msw, $psw, $qq2, $qjd);
			$pw = "<div class=\"pageswitch\">\n".$psw."</div>\n";
		}
// Blog or Item
		switch(TRUE) {
		case($mitem[1] != 'item') :
			$query .= ' ORDER BY '.$q5.' LIMIT '.$num.','.$mitem[0];
			$querys = array($query);
			break;
		default:
			$item =& $manager->getItem($itemid, 0, 0);
			$jc1 = ($mitem[2]) ? '<' : '>';
			$jc2 = ($mitem[2]) ? 'DESC' : 'ASC' ;
			$jc3 = ($mitem[2]) ? '>' : '<';
			$jc4 = ($mitem[2]) ? 'ASC' : 'DESC' ;
			sql_query('CREATE TEMPORARY TABLE snext as '.$query.' and itime '.$jc1.' "'.$item['itime'].'" ORDER BY itime '.$jc2.' LIMIT '.$mitem[0]);
			$qi1 = 'SELECT DISTINCT itemid, blog, body, author, authorname, timestamp, itime, more, authorid, category, catid, closed, authormail, authorurl, title FROM snext ORDER BY itime '.$jc4;
			$qi2 = $query.' and itime '.$jc3.' "'.$item['itime'].'" ORDER BY itime '.$jc4.' LIMIT '.$mitem[0];
			$query .= ' and inumber = '.$itemid.' LIMIT 1';
			$querys = array($qi1, $query, $qi2);
		}
// View
		$temple = explode('/', $template);
		if($msw[1] != 'a') echo $pw;
		$ii = '';
		if(substr($mitem[2] ,1, 1) == 'h') $mtemp = explode('/', $mitem[3]);
		foreach($querys as $query1) {
			$temp = ($ii == 1) ? $mitem[3] : $template;
			$jd = ($ii == 1) ? 1 : 0;
			switch(TRUE) {
			case($mitem[1] != 'item' && !$nums) :
				echo _NP_MULTITAGS_NOITEM;
				break;
			case(($gque || $_GET['search']) && $mtemp && $mtemp[0] == 'multitags') :
				$this->MultiTitle($mitem[3], $query1, $jd, $que, $mitem, $qq);
				break;
			case($_GET['search'] && $mtemp && substr($mitem[2] ,2, 1) == '1') :
				$blog->showUsingQuery($mitem[3], $query1, 1, 1, 1);
				break;
			case(($gque || $_GET['search']) && $mtemp && substr($mitem[2] ,2, 1) != '1') :
				$blog->showUsingQuery($mitem[3], $query1, 1, 1, 1);
				break;
			case($temple[0] == 'multitags') :
				$this->MultiTitle($temp, $query1, $jd, $que, $mitem, $qq);
				break;
			default :
				$blog->showUsingQuery($temp, $query1, 1, 1, 1);
			}
			$ii++;
		}
		if($msw[1] != 'b') echo $pw;
	}

	function TagSort($msort = '') {
		switch($msort) {
		case '' :
			break;
		case '2' :
			$query .= ' ORDER BY RAND()';
			break;
		case '6' :
			$query .= ' ORDER BY taglevel DESC';
			break;
		case '7' :
			$query .= ' ORDER BY taglevel';
			break;
		case '8' :
			$query .= ' ORDER BY taggroup, taglevel';
			break;
		case '9' :
			$query .= ' ORDER BY tagdesc';
			break;
		default :
			$query .= ' ORDER BY tagname';
		}
		return $query;
	}

	function TableForm($mode = '') {
		global $itemid, $CONF;
		if($mode == 1) $link = ' [*<a href="'.$CONF['PluginURL'].'multitags/index.php?act=itemedit&amp;id='.$itemid.'">'._NP_MULTITAGS_EDITTAG.'</a>]';
		echo '<h3>MultiTags</h3>'.
_NP_MULTITAGS_ADD.': <input type="text" name="multitags[0]" size="30" maxlength="255" value="" />'.$link.'<br />';
		switch($mode) {
		case 1 :
			$icat = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber = '.$itemid.' ORDER BY null LIMIT 1');
			$query = ' and !(tcatid REGEXP ",'.$icat.',")';
		}
		$tlevel = sql_query('SELECT DISTINCT taglevel FROM '.sql_table('plugin_multitags').' ORDER BY taglevel');
		while(list($c1) = mysql_fetch_row($tlevel)) $level[] = $c1;
		mysql_free_result($tlevel);
		if($mode) $this->TableFormView($level, $query, 2);
		$this->TableFormView($level, $query, $mode);
	}

	function TableFormView($level = '', $query = '', $mode = '') {
		global $itemid;
		foreach($level as $lev) {
			$field = '';
			if($mode == 2) $q2 = ' and titemid REGEXP ",'.$itemid.',"';
			$result = sql_query('SELECT tagid, tagname FROM '.sql_table('plugin_multitags').' WHERE taglevel = '.$lev.$q2.' ORDER BY tagname LIMIT 100');
			$field .= "<fieldset>\n<legend>"._NP_MULTITAGS_TAGLEVEL.$lev."</legend>\n";
			if($mode == 2) $check = ' checked="checked"';
			while($row = mysql_fetch_array($result)) {
				$jd = '';
				switch($mode) {
				case 1 :
					$ntag = sql_query('SELECT tagid FROM '.sql_table('plugin_multitags').' WHERE titemid REGEXP ",'.$itemid.',"');
					while($row2 = mysql_fetch_array($ntag)) {
						if($row['tagid'] == $row2['tagid']) $jd = 1;
					}
				}
				if(!$jd) $field .= '<label for='.$row['tagid'].'><input name="multitags['.$row['tagid'].']" value="'.$row['tagid'].'"'.$check.' type="checkbox" id="'.$row['tagid'].'" />'.$row['tagname']."</label> \n";
			}
			$field .= '</fieldset>';
			if(mysql_num_rows($result)) echo $field;
			mysql_free_result($result);
			if($mode != 2 && $this->getOption('tag_level') == $lev) break;
		}
		if($mode == 2) echo '<hr />';
	}

	function TableUpdate($no = '', $mode = '', $id = '', $ids = '', $noc = '') {
		if($ids == ',') $ids = '';
		if(substr($ids ,0, 1) == ',') $ids = substr($ids ,1);
		switch(TRUE) {
		case($ids) :
			$add = 'or tagid in ('.$ids.')';
			if($noc) $add .= ' and tagid != '.$noc;
			break;
		case($no == 'tcatid') :
			$cname = quickQuery('SELECT cname as result FROM '.sql_table('category').' WHERE catid = '.$id.' ORDER BY null LIMIT 1');
			$add = 'or tagname = "'.$cname.'"';
		}
		$res1 = sql_query('SELECT tagid, '.$no.', tagname FROM '.sql_table('plugin_multitags').' WHERE '.$no.' REGEXP ",'.$id.'," '.$add);
		while(list($c1, $c2, $c3) = mysql_fetch_row($res1)) {
			$c4 = $id.',';
			switch(TRUE) {
			case($ids) :
				$jd = (preg_match("/,$c1,/", ",$ids,")) ? 1 : 0;
				break;
			case($no == 'tcatid') :
				$jd = ($cname == $c3) ? 1 : 0;
			}
			switch(TRUE) {
			case(!mysql_num_rows($res1) && ($no == 'titemid' || $mode == 'del')) :
				return;
			case(!$jd || $mode == 'del') :
				$c2 = str_replace($c4, '', $c2);
				break;
			default:
				$c2 .= $c4;
			}
			sql_query("UPDATE ".sql_table('plugin_multitags')." SET $no = '".$c2."' WHERE tagid = '".$c1."'");
		}
		mysql_free_result($res1);
		if($no == 'tcatid' && $mode == 'up') $this->TableCatAdd($id);
	}

	function TableCatAdd($id = '') {
		if($id) $add = ' WHERE catid = '.$id;
		$res1 = sql_query('SELECT cname, catid, cdesc FROM '.sql_table('category').$add);
		while(list($c1, $c2, $c3) = mysql_fetch_row($res1)) {
			$this->AddTagS('tcatid', $c1, $c2, $c3);
		}
		mysql_free_result($res1);
	}

	function AddTag($ids = '', $id = '') {
		$words = explode('/', $ids);
		foreach($words as $word) $this->AddTagS('titemid', $word, $id);
	}

	function AddTagS($m1 = '', $word = '', $id = '', $cdesc = '') {
		$m2 = ($m1 == 'tcatid') ? 'titemid' : 'tcatid';
		$level = ($m1 == 'tcatid') ? 1 : $this->getOption('tag_level');
		$res2 = sql_query('SELECT tagid ,'.$m1.','.$m2.', taglevel, tagdesc FROM '.sql_table('plugin_multitags').' WHERE tagname = "'.$word.'"');
		$word = str_replace("'", "\'", $word);
		$cdesc = str_replace("'", "\'", $cdesc);
		switch(TRUE) {
		case(!mysql_num_rows($res2)) :
			$q1 = "INSERT INTO ".sql_table('plugin_multitags')." (tagname, $m1, $m2, taglevel, tagdesc) VALUES ('$word', ',$id,', ',', '$level', '$cdesc')";
			break;
		default :
			while(list($ca1, $ca2, $ca3) = mysql_fetch_row($res2)) {
				$ca2 = implode(',', array_unique(explode(',', $ca2.$id)));
				$q1 = "UPDATE ".sql_table('plugin_multitags')." SET $m1 = '".$ca2.",', $m2 = '".$ca3."' WHERE tagid = '".$ca1."'";
			}
			mysql_free_result($res2);
		}
		sql_query($q1);
	}

	function MultiTitle($template = '', $query = '', $jd = '', $que = '', $mitem = '', $qq = '') {
		$temple = explode('/', $template, 4);
		switch(TRUE) {
		case($temple[1] == 'tr'):
			$m1 = 'tr';
			$m1a = 'td';
			break;
		case(!$temple[1]):
			$m1 = 'div';
			$m1a = 'span';
			break;
		default:
			$m1 = $temple[1];
			$m1a = 'span';
		}
		$tp = sql_query($query);
		while($row = mysql_fetch_assoc($tp)) {
			echo '<'.$m1.' class="multitags_top">';
			switch(TRUE) {
			case($temple[3]) :
				$date = date($temple[3], $row['timestamp']);
				echo '
<'.$m1a.' class="multitags_date">'.$date.' </'.$m1a.'>';
			}
			switch(TRUE) {
			case($jd == 1) :
				echo '<'.$m1a.' class="multitags_title">'.$row['title'].'</'.$m1a.'>';
				break;
			default :
				$ilink = $this->ItemURL($row['itemid'], $que, $qq, $mitem, $tagset);
				echo '<'.$m1a.' class="multitags_title"><a href="'.$ilink.'">'.$row['title'].'</a></'.$m1a.'>';
			}
			switch(TRUE) {
			case(substr($temple[2], 2, 1) == 't') :
				$tem = substr($temple[2], 0, 2);
				if(substr($temple[2], 3, 2) == 'br') $br = '<br />';
				echo $br."\n<".$m1a.' class="multitags_cat">'.$this->TagList($row['itemid'],10 , $tem).'</'.$m1a.'>';
				break;
			case($temple[2]) :
				echo "\n<".$m1a.' class="multitags_cat">'.substr($temple[2], 0, 1).$row['category'].substr($temple[2], 1, 1).'</'.$m1a.'>';
			}
			echo $this->EditItemTag($row['itemid'])."\n</".$m1.">\n";
		}
		mysql_free_result($tp);
		return;
	}

	function QueryChange($qq = '') {
		$order = (_CHARSET == 'EUC-JP') ? 'EUC-JP, UTF-8,' : 'UTF-8, EUC-JP,';
		$qq = mb_convert_encoding($qq, _CHARSET, $order.' JIS, SJIS, ASCII');
		$qq = mb_convert_kana($qq, 's');
		$qq = preg_replace('/('._NP_MULTITAGS_SPACE.')+/',' ',$qq);
		return $qq;
	}

	function TagChange(&$text, $nums = '') {
		global $blogid;
		if(!$nums) $nums = 300;
		if($nums != 'a') $text = strip_tags($text);
		$que = $this->getOption('tag_query');
		$qq = $this->TagQuery(0, $que, 1);
		switch(TRUE) {
		case(!$_GET['search'] && !$_GET['query'] && $nums != 'a') :
			$text = (_CHARSET == 'EUC-JP') ? mb_strimwidth($text, 0, $nums, '...', euc) : mb_strimwidth($text, 0, $nums, '...', utf8);
			break;
		default :
			$qq = $this->QueryChange(' '.$_GET['search'].$_GET['query']);
			$qq = explode(' ', htmlspecialchars(trim($qq)));
			if($nums != 'a') $num = mb_strpos($text, $qq[0]);
			$num = ($num<=30) ? 0 : $num-30 ;
			if($num) $add = '...';
			if($nums != 'a') $text = (_CHARSET == 'EUC-JP') ? $add.mb_strimwidth($text, $num, $nums, $add, euc) : $add.mb_strimwidth($text, $num, $nums, $add, utf8);
			foreach($qq as $qq1) $text = str_replace($qq1, '<span class="highlight">'.$qq1.'</span>', $text);
			if($nums == 'a') return $text;
		}
		$result = sql_query('SELECT tagid, tagname FROM '.sql_table('plugin_multitags').' ORDER BY null');
		while(list($c1, $c2) = mysql_fetch_row($result)) {
			if($this->getOption('tag_key') == 'yes' && $qq[0] && !$_GET['search'] && !$_GET['query']) $c1 = $qq[0].' '.$c1;
			$text = str_replace($c2, '<a class="tagkeyword" href="'.$this->FancyURL($blogid, $que, $c1).'">'.$c2.'</a>', $text);
		}
		return $text;
	}

	function TagQuery($tagset = '', $que = '', $temple = '', $mitem = '') {
		global $CONF;
		switch(TRUE) {
		case(!$tagset && !$_GET['search'] && $CONF['URLMode'] != 'normal' && !$_GET[$que] && !$_GET['query']) :
			$lq = explode('/'.$que.'/', $_SERVER['REQUEST_URI']);
			$lr = explode('/', $lq[1]);
			$ls = explode('?', $lr[0]);
			$qq = str_replace('+' ,' ', $ls[0]);
			break;
		case(!$tagset && !$_GET['search']) :
			$qq = $_GET[$que];
			break;
		case($tagset) :
			$qq = $mitem;
			break;
		case($_GET['search'] && $temple != 'tag' && $temple != 1) :
			$qq = $_GET['search'];
		}
		return array($qq, $lq);
	}

	function EditItemTag($itemid = '') {
		global $CONF, $member;
		if(!($member->isLoggedIn() && $member->isAdmin())) return;
		return ' <span style="font-size: 10px; color: gray;">(<a href="'.$CONF['AdminURL'].'bookmarklet.php?action=edit&amp;itemid='.$itemid.'" target="_blank" title="'._NP_MULTITAGS_EDITITEM.'">Ed</a>-<a href="'.$CONF['PluginURL'].'multitags/index.php?act=itemedit&amp;id='.$itemid.'" target="_blank" title="'._NP_MULTITAGS_EDITTAG.'">MT</a>)</span>';
	}

	function SerchForm($qq = '', $que = '', $msw = '', $psw = '', $qq2 = '', $qjd = '') {
		global $blogid, $CONF;
		if(!$_GET['search'] && !$_GET['query']) $qq = '';
/*
		switch(TRUE) {
		case(!$_GET['search'] && !$_GET['query']) :
			$qq = '';
			$tname  = ($qjd) ? 'tagname' : 'tagid';
			foreach($qq2 as $qq_e) $qq .= quickQuery('SELECT tagname as result FROM '.sql_table('plugin_multitags').' WHERE '.$tname.' = "'.$qq_e.'"').' ';
		}
*/
		$bid = ($msw[3] > 0) ? $msw[3] : $blogid;
		$form = explode('/', $this->getOption('tag_form'));
		if($msw[4] != 1) $bt = '<input value="'._SEARCHFORM_SUBMIT.'" class="formbutton" accesskey="5" type="submit" />';
		$sf = '<form method="get" action="'.$CONF['BlogURL'].'">
<div class="tagform">
'.$psw.$npmt.'
<input name="blogid" value="'.$bid.'" type="hidden" />
<input name="search" class="formfield" size="'.$form[0].'" maxlength="'.$form[1].'" accesskey="4" value="'.trim($qq).'" />
'.$bt.'
</div>
</form>';
		return $sf;
	}

	function GetCatName($md = '', $iid = '') {
		global $itemid, $catid;
		if($iid) $itemid = $iid;
		if($itemid) $catid = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
		$c1 = quickQuery('SELECT tagid as result FROM '.sql_table('plugin_multitags').' ,'.sql_table('category').' WHERE tcatid REGEXP ",'.$catid.',"');
		return $c1;
	}

	function TagNavi($qq2 = '', $bid = '', $que = '', $qjd = '', $gque = '', $jd = '') {
		global $CONF, $itemid, $catid;
		$t1 = '<div class="tagnavi">
<a href="'.$CONF['BlogURL'].$npmt."\">HOME</a> &raquo; \n";
		switch(TRUE) {
		case(($itemid || $catid) && !$gque) :
			$qq2 = array($this->GetCatName(1));
			break;
		case($_GET['search'] || $_GET['query']) :
			$t3 = _NP_MULTITAGS_SEARCH.'"'.$_GET['search'].$_GET['query']."\"</div>\n";
			if($jd) return strip_tags($t3);
			return $t1.$t3;
		}
		$ii = '';
		$s2t = '';
		$lqq = array_slice($qq2, -1);
		foreach($qq2 as $s2b) {
			$tname  = ($qjd) ? 'tagname' : 'tagid';
			if($s2b) {
				$c1 = quickQuery('SELECT tagname as result FROM '.sql_table('plugin_multitags').' WHERE '.$tname.' = "'.$s2b.'"');
				$s2b = stripslashes($s2b);
				if($ii && !$jd) $back = '<span class="tagnum">(<a href="'.$this->FancyURL($bid, $que, $s2b, 1).'" title="Back to ['.$c1."]\">@</a>)</span>\n";
				$s2t = trim($s2t.' '.$s2b);
				$t2 .= '<a href="'.$this->FancyURL($bid, $que, $s2t, 1).'">'.$c1.'</a>'.$back." &raquo; \n";
				$ii++;
			}
		}
		if($itemid && $jd != 2) $t2 .= quickQuery('SELECT ititle as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
		$t2 .= "</div>\n";
		if($jd) {
			$t2 = str_replace(array("\r", "\n", "\r\n"), "", $t2);
			if($jd == 2) $t2 = str_replace("&raquo; ", "", $t2);
			return strip_tags($t2);
		}
		return $t1.$t2;
	}

	function ItemURL($iid = '', $que = '', $qq = '', $mitem = '', $tagset = '') {
		global $CONF;
		$qq = urlencode(trim($qq));
		if($CONF['URLMode'] == 'normal' || $this->getOption('tag_url') == 2) $jd = 1;
		$link = ($jd) ? '?itemid='.$iid : '/item/'.$iid;
		if($qq && !$tagset && $mitem[1] != 'non' && $mitem[1] != 'item' && !$_GET['query'] && !$_GET['search']) $link .= ($jd) ? '&amp;'.$que.'='.$qq : '/'.$que.'/'.$qq;
		return $CONF['BlogURL'].$link.$npmt;
	}

	function FancyURL($bid = '', $que = '', $qq = '', $ijd = '') {
		global $CONF, $archive;
		$qq2 = array_unique(explode(' ', $qq));
		$qqt = implode(',', $qq2);
		$mlevel = @quickQuery('SELECT MAX(taglevel) as result FROM '.sql_table('plugin_multitags').' WHERE tagid in ('.$qqt.') ORDER BY null');
		for($i=1; $i<($mlevel-count($qq2)); $i++) $qq0 .= ' '.$qq2[0];
		$qq = urlencode(implode(' ', $qq2).$qq0);
		$turl = $this->getOption('tag_url');
		switch(TRUE) {
		case($CONF['URLMode'] == 'normal' || $turl == 2) :
			if($archive && !$ijd) $ar = '&amp;archive='.$archive;
			if($turl != 1) $bids = 'blogid='.$bid.'&amp;';
			$link = $CONF['BlogURL'].'?'.$bids.$que.'='.$qq.$ar;
			break;
		default:
			if($archive && !$ijd) $ar = '/archive/'.$archive;
			if(!$turl) $bb = '/blog/'.$bid;
			$link = $CONF['BlogURL'].$bb.'/'.$que.'/'.$qq.$ar;
		}
		return $link.$npmt;
	}
}
?>